Index: palm/trunk/SOURCE/radiation_model_mod.f90
===================================================================
--- palm/trunk/SOURCE/radiation_model_mod.f90	(revision 3322)
+++ palm/trunk/SOURCE/radiation_model_mod.f90	(revision 3337)
@@ -5814,30 +6232,27 @@
                   az1 = az2 - azs
                   !TODO precalculate after 1st line
-                  vffrac(:) = (SIN(az2) - SIN(az1))                           &
+                  vffrac(itarg0:itarg1) = (SIN(az2) - SIN(az1))               &
                               * (zbdry(1:nzn) - zbdry(0:nzn-1)                &
                                  + SIN(zbdry(0:nzn-1))*COS(zbdry(0:nzn-1))    &
                                  - SIN(zbdry(1:nzn))*COS(zbdry(1:nzn)))       &
                               / (2._wp * pi)
-                  !--sum of vffrac for all iaz equals 1, verified
+!--               sum of whole vffrac equals 1, verified
                ENDIF
                yxdir = (/ COS(azmid), SIN(azmid) /)
-               CALL raytrace_2d(ta, yxdir, zdirs,                              &
-                               surfstart(myid) + isurflt, facearea(td),        &
-                               vffrac, .TRUE., .FALSE., win_lad, horizon,       &
-                               ztransp)
-               
-
-               azen = pi/2 - ATAN(horizon)
-               IF ( td == iup_u  .OR.  td == iup_l )  THEN
-                  azen = MIN(azen, pi/2) !only above horizontal direction
-                  skyvf(isurflt) = skyvf(isurflt) + (1._wp - COS(2*azen)) /   &
-                     (2._wp * raytrace_discrete_azims)
-               ELSE
-                  skyvf(isurflt) = skyvf(isurflt) + (SIN(az2) - SIN(az1)) *   &
-                              (azen - SIN(azen)*COS(azen)) / (2._wp*pi)
-               ENDIF
-               skyvft(isurflt) = skyvft(isurflt) + SUM(ztransp(:) * vffrac(:))
+               CALL raytrace_2d(ta, yxdir, nzn, zdirs,                        &
+                                    surfstart(myid) + isurflt, facearea(td),  &
+                                    vffrac(itarg0:itarg1), .TRUE., .TRUE.,    &
+                                    .FALSE., lowest_free_ray,                 &
+                                    ztransp(itarg0:itarg1),                   &
+                                    itarget(itarg0:itarg1))   !FIXME unit vect in grid units + zdirs
+                                                              !FIXME itarget available only in
+                                                              !case of rad_angular_discretization
+               skyvf(isurflt) = skyvf(isurflt) + &
+                                SUM(vffrac(itarg0:itarg0+lowest_free_ray-1))
+               skyvft(isurflt) = skyvft(isurflt) + &
+                                 SUM(ztransp(itarg0:itarg0+lowest_free_ray-1) &
+                                             * vffrac(itarg0:itarg0+lowest_free_ray-1))
  
-               !--Save direct solar transparency
+!--            Save direct solar transparency
                j = MODULO(NINT(azmid/                                          &
                                (2._wp*pi)*raytrace_discrete_azims-.5_wp, iwp), &
@@ -5846,61 +6261,40 @@
                DO k = 1, raytrace_discrete_elevs/2
                   i = dsidir_rev(k-1, j)
-                  IF ( i /= -1 )  dsitrans(isurflt, i) = ztransp(k)
+                  IF ( i /= -1  .AND.  k <= lowest_free_ray )  &
+                     dsitrans(isurflt, i) = ztransp(itarg0+k-1)
                ENDDO
+
+               !
+               !--Advance itarget indices
+               itarg0 = itarg1 + 1
+               itarg1 = itarg1 + nzn
             ENDDO
 
-            DEALLOCATE ( zdirs, zbdry, vffrac, ztransp )
-!
-!--         Following calculations only required for surface_reflections
-            IF ( surface_reflections )  THEN
-
-               DO  isurfs = 1, nsurf
-                  IF ( .NOT.  surface_facing(surfl(ix, isurflt), surfl(iy, isurflt), &
-                     surfl(iz, isurflt), surfl(id, isurflt), &
-                     surf(ix, isurfs), surf(iy, isurfs), &
-                     surf(iz, isurfs), surf(id, isurfs)) )  THEN
-                     CYCLE
+            IF ( rad_angular_discretization )  THEN
+!--            sort itarget by face id
+               CALL quicksort_itarget(itarget,vffrac,ztransp,1,nzn*naz)
+!
+!--            find the first valid position
+               itarg0 = 1
+               DO WHILE ( itarg0 <= nzn*naz )
+                  IF ( itarget(itarg0) /= -1 )  EXIT
+                  itarg0 = itarg0 + 1
+               ENDDO
+
+               DO  i = itarg0, nzn*naz
+!
+!--               For duplicate values, only sum up vf fraction value
+                  IF ( i < nzn*naz )  THEN
+                     IF ( itarget(i+1) == itarget(i) )  THEN
+                        vffrac(i+1) = vffrac(i+1) + vffrac(i)
+                        CYCLE
+                     ENDIF
                   ENDIF
-                  
-                  sd = surf(id, isurfs)
-                  sa = (/ REAL(surf(iz, isurfs), wp) - 0.5_wp * kdir(sd),  &
-                          REAL(surf(iy, isurfs), wp) - 0.5_wp * jdir(sd),  &
-                          REAL(surf(ix, isurfs), wp) - 0.5_wp * idir(sd)  /)
-
-!--               unit vector source -> target
-                  uv = (/ (ta(1)-sa(1))*dz(1), (ta(2)-sa(2))*dy, (ta(3)-sa(3))*dx /)
-                  sqdist = SUM(uv(:)**2)
-                  uv = uv / SQRT(sqdist)
-
-!--               reject raytracing above max distance
-                  IF ( SQRT(sqdist) > max_raytracing_dist ) THEN
-                     ray_skip_maxdist = ray_skip_maxdist + 1
-                     CYCLE
-                  ENDIF
-                 
-!--               irradiance factor (our unshaded shape view factor) = view factor per differential target area * source area
-                  rirrf = dot_product((/ kdir(sd), jdir(sd), idir(sd) /), uv) & ! cosine of source normal and direction
-                      * dot_product((/ kdir(td), jdir(td), idir(td) /), -uv) &  ! cosine of target normal and reverse direction
-                      / (pi * sqdist) & ! square of distance between centers
-                      * facearea(sd)
-
-!--               reject raytracing for potentially too small view factor values
-                  IF ( rirrf < min_irrf_value ) THEN
-                      ray_skip_minval = ray_skip_minval + 1
-                      CYCLE
-                  ENDIF
-
-!--               raytrace + process plant canopy sinks within
-                  CALL raytrace(sa, ta, isurfs, rirrf, facearea(td), .TRUE., &
-                                visible, transparency, win_lad)
-
-                  IF ( .NOT.  visible ) CYCLE
-                 ! rsvf = rirrf * transparency
-
+!
 !--               write to the svf array
                   nsvfl = nsvfl + 1
 !--               check dimmension of asvf array and enlarge it if needed
                   IF ( nsvfla < nsvfl )  THEN
-                     k = nsvfla * 2
+                     k = CEILING(REAL(nsvfla, kind=wp) * grow_factor)
                      IF ( msvf == 0 )  THEN
                         msvf = 1
@@ -5917,6 +6311,88 @@
                      ENDIF
 
-!                      WRITE(msg,'(A,3I12)') 'Grow asvf:',nsvfl,nsvfla,k
-!                      CALL radiation_write_debug_log( msg )
+                     WRITE (msg,'(A,3I12)') 'Grow asvf:',nsvfl,nsvfla,k
+                     CALL radiation_write_debug_log( msg )
+                     
+                     nsvfla = k
+                  ENDIF
+!--               write svf values into the array
+                  asvf(nsvfl)%isurflt = isurflt
+                  asvf(nsvfl)%isurfs = itarget(i)
+                  asvf(nsvfl)%rsvf = vffrac(i)
+                  asvf(nsvfl)%rtransp = ztransp(i)
+               END DO
+
+            ENDIF ! rad_angular_discretization
+
+            DEALLOCATE ( zdirs, zbdry, vffrac, ztransp, itarget ) !FIXME itarget shall be allocated only
+                                                                  !in case of rad_angular_discretization
+!
+!--         Following calculations only required for surface_reflections
+            IF ( surface_reflections  .AND.  .NOT. rad_angular_discretization )  THEN
+
+               DO  isurfs = 1, nsurf
+                  IF ( .NOT.  surface_facing(surfl(ix, isurflt), surfl(iy, isurflt), &
+                     surfl(iz, isurflt), surfl(id, isurflt), &
+                     surf(ix, isurfs), surf(iy, isurfs), &
+                     surf(iz, isurfs), surf(id, isurfs)) )  THEN
+                     CYCLE
+                  ENDIF
+                  
+                  sd = surf(id, isurfs)
+                  sa = (/ REAL(surf(iz, isurfs), wp) - 0.5_wp * kdir(sd),  &
+                          REAL(surf(iy, isurfs), wp) - 0.5_wp * jdir(sd),  &
+                          REAL(surf(ix, isurfs), wp) - 0.5_wp * idir(sd)  /)
+
+!--               unit vector source -> target
+                  uv = (/ (ta(1)-sa(1))*dz(1), (ta(2)-sa(2))*dy, (ta(3)-sa(3))*dx /)
+                  sqdist = SUM(uv(:)**2)
+                  uv = uv / SQRT(sqdist)
+
+!--               reject raytracing above max distance
+                  IF ( SQRT(sqdist) > max_raytracing_dist ) THEN
+                     ray_skip_maxdist = ray_skip_maxdist + 1
+                     CYCLE
+                  ENDIF
+                 
+!--               irradiance factor (our unshaded shape view factor) = view factor per differential target area * source area
+                  rirrf = dot_product((/ kdir(sd), jdir(sd), idir(sd) /), uv) & ! cosine of source normal and direction
+                      * dot_product((/ kdir(td), jdir(td), idir(td) /), -uv) &  ! cosine of target normal and reverse direction
+                      / (pi * sqdist) & ! square of distance between centers
+                      * facearea(sd)
+
+!--               reject raytracing for potentially too small view factor values
+                  IF ( rirrf < min_irrf_value ) THEN
+                      ray_skip_minval = ray_skip_minval + 1
+                      CYCLE
+                  ENDIF
+
+!--               raytrace + process plant canopy sinks within
+                  CALL raytrace(sa, ta, isurfs, rirrf, facearea(td), .TRUE., &
+                                visible, transparency)
+
+                  IF ( .NOT.  visible ) CYCLE
+                 ! rsvf = rirrf * transparency
+
+!--               write to the svf array
+                  nsvfl = nsvfl + 1
+!--               check dimmension of asvf array and enlarge it if needed
+                  IF ( nsvfla < nsvfl )  THEN
+                     k = CEILING(REAL(nsvfla, kind=wp) * grow_factor)
+                     IF ( msvf == 0 )  THEN
+                        msvf = 1
+                        ALLOCATE( asvf1(k) )
+                        asvf => asvf1
+                        asvf1(1:nsvfla) = asvf2
+                        DEALLOCATE( asvf2 )
+                     ELSE
+                        msvf = 0
+                        ALLOCATE( asvf2(k) )
+                        asvf => asvf2
+                        asvf2(1:nsvfla) = asvf1
+                        DEALLOCATE( asvf1 )
+                     ENDIF
+
+                     WRITE(msg,'(A,3I12)') 'Grow asvf:',nsvfl,nsvfla,k
+                     CALL radiation_write_debug_log( msg )
                      
                      nsvfla = k
@@ -5931,7 +6407,7 @@
         ENDDO
 
-        !--Raytrace to canopy boxes to fill dsitransc TODO optimize
-        !--
-        dsitransc(:,:) = -999._wp !FIXME
+!--
+!--     Raytrace to canopy boxes to fill dsitransc TODO optimize
+        dsitransc(:,:) = 0._wp
         az0 = 0._wp
         naz = raytrace_discrete_azims
@@ -5940,39 +6416,196 @@
         nzn = raytrace_discrete_elevs / 2
         zns = pi / 2._wp / REAL(nzn, wp)
-        ALLOCATE ( zdirs(1:nzn), vffrac(1:nzn), ztransp(1:nzn) )
+        ALLOCATE ( zdirs(1:nzn), vffrac(1:nzn), ztransp(1:nzn), &
+               itarget(1:nzn) )
         zdirs(:) = (/( TAN(pi/2 - (zn0+(REAL(izn,wp)-.5_wp)*zns)), izn=1, nzn )/)
         vffrac(:) = 0._wp
 
-        DO ipcgb = 1, npcbl
+        DO  ipcgb = 1, npcbl
            ta = (/ REAL(pcbl(iz, ipcgb), wp),  &
                    REAL(pcbl(iy, ipcgb), wp),  &
                    REAL(pcbl(ix, ipcgb), wp) /)
-           !--Calculate sky-view factor and direct solar visibility using 2D raytracing
-           DO iaz = 1, naz
+!--        Calculate direct solar visibility using 2D raytracing
+           DO  iaz = 1, naz
               azmid = az0 + (REAL(iaz, wp) - .5_wp) * azs
               yxdir = (/ COS(azmid), SIN(azmid) /)
-              CALL raytrace_2d(ta, yxdir, zdirs,     &
-                                   -999, -999._wp, vffrac, .FALSE., .TRUE., &
-                                   win_lad, horizon, ztransp)
-
-              !--Save direct solar transparency
+              CALL raytrace_2d(ta, yxdir, nzn, zdirs,                                &
+                                   -999, -999._wp, vffrac, .FALSE., .FALSE., .TRUE., &
+                                   lowest_free_ray, ztransp, itarget) !FIXME unit vect in grid units + zdirs
+
+!--           Save direct solar transparency
               j = MODULO(NINT(azmid/                                         &
                              (2._wp*pi)*raytrace_discrete_azims-.5_wp, iwp), &
                          raytrace_discrete_azims)
-              DO k = 1, raytrace_discrete_elevs/2
+              DO  k = 1, raytrace_discrete_elevs/2
                  i = dsidir_rev(k-1, j)
-                 IF ( i /= -1 )  dsitransc(ipcgb, i) = ztransp(k)
+                 IF ( i /= -1  .AND.  k <= lowest_free_ray ) &
+                    dsitransc(ipcgb, i) = ztransp(k)
               ENDDO
            ENDDO
         ENDDO
-        DEALLOCATE ( zdirs, vffrac, ztransp )
-
-!         CALL radiation_write_debug_log( 'End of calculation SVF' )
-!         WRITE(msg, *) 'Raytracing skipped for maximum distance of ', &
-!             max_raytracing_dist, ' m on ', ray_skip_maxdist, ' pairs.'
-!         CALL radiation_write_debug_log( msg )
-!         WRITE(msg, *) 'Raytracing skipped for minimum potential value of ', &
-!             min_irrf_value , ' on ', ray_skip_minval, ' pairs.'
-!         CALL radiation_write_debug_log( msg )
+        DEALLOCATE ( zdirs, vffrac, ztransp, itarget )
+!--
+!--     Raytrace to MRT boxes
+        IF ( nmrtbl > 0 )  THEN
+           mrtdsit(:,:) = 0._wp
+           mrtsky(:) = 0._wp
+           mrtskyt(:) = 0._wp
+           az0 = 0._wp
+           naz = raytrace_discrete_azims
+           azs = 2._wp * pi / REAL(naz, wp)
+           zn0 = 0._wp
+           nzn = raytrace_discrete_elevs
+           zns = pi / REAL(nzn, wp)
+           ALLOCATE ( zdirs(1:nzn), zbdry(0:nzn), vffrac(1:nzn*naz), vffrac0(1:nzn), &
+                      ztransp(1:nzn*naz), itarget(1:nzn*naz) )   !FIXME allocate itarget only
+                                                                 !in case of rad_angular_discretization
+
+           zdirs(:) = (/( TAN(pi/2 - (zn0+(REAL(izn,wp)-.5_wp)*zns)), izn=1, nzn )/)
+           zbdry(:) = (/( zn0+REAL(izn,wp)*zns, izn=0, nzn )/)
+           vffrac0(:) = (COS(zbdry(0:nzn-1)) - COS(zbdry(1:nzn))) / 2._wp / REAL(naz, wp)
+
+           DO  imrt = 1, nmrtbl
+              ta = (/ REAL(mrtbl(iz, imrt), wp),  &
+                      REAL(mrtbl(iy, imrt), wp),  &
+                      REAL(mrtbl(ix, imrt), wp) /)
+!
+!--           vf fractions are constant per azimuth
+              DO iaz = 0, naz-1
+                 vffrac(iaz*nzn+1:(iaz+1)*nzn) = vffrac0(:)
+              ENDDO
+!--           sum of whole vffrac equals 1, verified
+              itarg0 = 1
+              itarg1 = nzn
+!
+!--           Calculate sky-view factor and direct solar visibility using 2D raytracing
+              DO  iaz = 1, naz
+                 azmid = az0 + (REAL(iaz, wp) - .5_wp) * azs
+                 CALL raytrace_2d(ta, (/ COS(azmid), SIN(azmid) /), nzn, zdirs,  &
+                                  -999, -999._wp, vffrac(itarg0:itarg1), .TRUE., &
+                                  .FALSE., .TRUE., lowest_free_ray,              &
+                                  ztransp(itarg0:itarg1),                        &
+                                  itarget(itarg0:itarg1))   !FIXME unit vect in grid units + zdirs
+                                                            !FIXME itarget available only in
+                                                            !case of rad_angular_discretization
+
+!--              Sky view factors for MRT
+                 mrtsky(imrt) = mrtsky(imrt) + &
+                                  SUM(vffrac(itarg0:itarg0+lowest_free_ray-1))
+                 mrtskyt(imrt) = mrtskyt(imrt) + &
+                                   SUM(ztransp(itarg0:itarg0+lowest_free_ray-1) &
+                                               * vffrac(itarg0:itarg0+lowest_free_ray-1))
+!--              Direct solar transparency for MRT
+                 j = MODULO(NINT(azmid/                                         &
+                                (2._wp*pi)*raytrace_discrete_azims-.5_wp, iwp), &
+                            raytrace_discrete_azims)
+                 DO  k = 1, raytrace_discrete_elevs/2
+                    i = dsidir_rev(k-1, j)
+                    IF ( i /= -1  .AND.  k <= lowest_free_ray ) &
+                       mrtdsit(imrt, i) = ztransp(itarg0+k-1)
+                 ENDDO
+!
+!--              Advance itarget indices
+                 itarg0 = itarg1 + 1
+                 itarg1 = itarg1 + nzn
+              ENDDO
+
+!--           sort itarget by face id
+              CALL quicksort_itarget(itarget,vffrac,ztransp,1,nzn*naz)
+!
+!--           find the first valid position
+              itarg0 = 1
+              DO WHILE ( itarg0 <= nzn*naz )
+                 IF ( itarget(itarg0) /= -1 )  EXIT
+                 itarg0 = itarg0 + 1
+              ENDDO
+
+              DO  i = itarg0, nzn*naz
+!
+!--              For duplicate values, only sum up vf fraction value
+                 IF ( i < nzn*naz )  THEN
+                    IF ( itarget(i+1) == itarget(i) )  THEN
+                       vffrac(i+1) = vffrac(i+1) + vffrac(i)
+                       CYCLE
+                    ENDIF
+                 ENDIF
+!
+!--              write to the mrtf array
+                 nmrtf = nmrtf + 1
+!--              check dimmension of mrtf array and enlarge it if needed
+                 IF ( nmrtfa < nmrtf )  THEN
+                    k = CEILING(REAL(nmrtfa, kind=wp) * grow_factor)
+                    IF ( mmrtf == 0 )  THEN
+                       mmrtf = 1
+                       ALLOCATE( amrtf1(k) )
+                       amrtf => amrtf1
+                       amrtf1(1:nmrtfa) = amrtf2
+                       DEALLOCATE( amrtf2 )
+                    ELSE
+                       mmrtf = 0
+                       ALLOCATE( amrtf2(k) )
+                       amrtf => amrtf2
+                       amrtf2(1:nmrtfa) = amrtf1
+                       DEALLOCATE( amrtf1 )
+                    ENDIF
+
+                    WRITE (msg,'(A,3I12)') 'Grow amrtf:', nmrtf, nmrtfa, k
+                    CALL radiation_write_debug_log( msg )
+
+                    nmrtfa = k
+                 ENDIF
+!--              write mrtf values into the array
+                 amrtf(nmrtf)%isurflt = imrt
+                 amrtf(nmrtf)%isurfs = itarget(i)
+                 amrtf(nmrtf)%rsvf = vffrac(i)
+                 amrtf(nmrtf)%rtransp = ztransp(i)
+              ENDDO ! itarg
+
+           ENDDO ! imrt
+           DEALLOCATE ( zdirs, zbdry, vffrac, vffrac0, ztransp, itarget )
+!
+!--        Move MRT factors to final arrays
+           ALLOCATE ( mrtf(nmrtf), mrtft(nmrtf), mrtfsurf(2,nmrtf) )
+           DO  imrtf = 1, nmrtf
+              mrtf(imrtf) = amrtf(imrtf)%rsvf
+              mrtft(imrtf) = amrtf(imrtf)%rsvf * amrtf(imrtf)%rtransp
+              mrtfsurf(:,imrtf) = (/amrtf(imrtf)%isurflt, amrtf(imrtf)%isurfs /)
+           ENDDO
+           IF ( ALLOCATED(amrtf1) )  DEALLOCATE( amrtf1 )
+           IF ( ALLOCATED(amrtf2) )  DEALLOCATE( amrtf2 )
+        ENDIF ! nmrtbl > 0
+
+        IF ( rad_angular_discretization )  THEN
+#if defined( __parallel )
+!--        finalize MPI_RMA communication established to get global index of the surface from grid indices
+!--        flush all MPI window pending requests
+           CALL MPI_Win_flush_all(win_gridsurf, ierr)
+           IF ( ierr /= 0 ) THEN
+               WRITE(9,*) 'Error MPI_Win_flush_all1:', ierr, win_gridsurf
+               FLUSH(9)
+           ENDIF
+!--        unlock MPI window
+           CALL MPI_Win_unlock_all(win_gridsurf, ierr)
+           IF ( ierr /= 0 ) THEN
+               WRITE(9,*) 'Error MPI_Win_unlock_all1:', ierr, win_gridsurf
+               FLUSH(9)
+           ENDIF
+!--        free MPI window
+           CALL MPI_Win_free(win_gridsurf, ierr)
+           IF ( ierr /= 0 ) THEN
+               WRITE(9,*) 'Error MPI_Win_free1:', ierr, win_gridsurf
+               FLUSH(9)
+           ENDIF
+#else
+           DEALLOCATE ( gridsurf )
+#endif
+        ENDIF
+
+        CALL radiation_write_debug_log( 'End of calculation SVF' )
+        WRITE(msg, *) 'Raytracing skipped for maximum distance of ', &
+           max_raytracing_dist, ' m on ', ray_skip_maxdist, ' pairs.'
+        CALL radiation_write_debug_log( msg )
+        WRITE(msg, *) 'Raytracing skipped for minimum potential value of ', &
+           min_irrf_value , ' on ', ray_skip_minval, ' pairs.'
+        CALL radiation_write_debug_log( msg )
 
         CALL location_message( '    waiting for completion of SVF and CSF calculation in all processes', .TRUE. )
@@ -5983,14 +6616,25 @@
 !--         finalize mpi_rma communication and deallocate temporary arrays
 #if defined( __parallel )
-            IF ( rma_lad_raytrace )  THEN
+            IF ( raytrace_mpi_rma )  THEN
                 CALL MPI_Win_flush_all(win_lad, ierr)
+                IF ( ierr /= 0 ) THEN
+                    WRITE(9,*) 'Error MPI_Win_flush_all2:', ierr, win_lad
+                    FLUSH(9)
+                ENDIF
 !--             unlock MPI window
                 CALL MPI_Win_unlock_all(win_lad, ierr)
+                IF ( ierr /= 0 ) THEN
+                    WRITE(9,*) 'Error MPI_Win_unlock_all2:', ierr, win_lad
+                    FLUSH(9)
+                ENDIF
 !--             free MPI window
                 CALL MPI_Win_free(win_lad, ierr)
-                
+                IF ( ierr /= 0 ) THEN
+                    WRITE(9,*) 'Error MPI_Win_free2:', ierr, win_lad
+                    FLUSH(9)
+                ENDIF
 !--             deallocate temporary arrays storing values for csf calculation during raytracing
                 DEALLOCATE( lad_s_ray )
-!--             sub_lad is the pointer to lad_s_rma in case of rma_lad_raytrace
+!--             sub_lad is the pointer to lad_s_rma in case of raytrace_mpi_rma
 !--             and must not be deallocated here
             ELSE
@@ -6009,47 +6653,60 @@
         CALL location_message( '    calculation of the complete SVF array', .TRUE. )
 
-!         CALL radiation_write_debug_log( 'Start SVF sort' )
-!--     sort svf ( a version of quicksort )
-        CALL quicksort_svf(asvf,1,nsvfl)
-
-        !< load svf from the structure array to plain arrays
-!         CALL radiation_write_debug_log( 'Load svf from the structure array to plain arrays' )
-        ALLOCATE( svf(ndsvf,nsvfl) )
-        ALLOCATE( svfsurf(idsvf,nsvfl) )
-        svfnorm_counts(:) = 0._wp
-        isurflt_prev = -1
-        ksvf = 1
-        svfsum = 0._wp
-        DO isvf = 1, nsvfl
-!--         normalize svf per target face
-            IF ( asvf(ksvf)%isurflt /= isurflt_prev )  THEN
-                IF ( isurflt_prev /= -1  .AND.  svfsum /= 0._wp )  THEN
-                    !< update histogram of logged svf normalization values
-                    i = searchsorted(svfnorm_report_thresh, svfsum / (1._wp-skyvf(isurflt_prev)))
-                    svfnorm_counts(i) = svfnorm_counts(i) + 1
-
-                    svf(1, isvf_surflt:isvf-1) = svf(1, isvf_surflt:isvf-1) / svfsum * (1._wp-skyvf(isurflt_prev))
-                ENDIF
-                isurflt_prev = asvf(ksvf)%isurflt
-                isvf_surflt = isvf
-                svfsum = asvf(ksvf)%rsvf !?? / asvf(ksvf)%rtransp
-            ELSE
-                svfsum = svfsum + asvf(ksvf)%rsvf !?? / asvf(ksvf)%rtransp
-            ENDIF
-
-            svf(:, isvf) = (/ asvf(ksvf)%rsvf, asvf(ksvf)%rtransp /)
-            svfsurf(:, isvf) = (/ asvf(ksvf)%isurflt, asvf(ksvf)%isurfs /)
-
-!--         next element
-            ksvf = ksvf + 1
-        ENDDO
-
-        IF ( isurflt_prev /= -1  .AND.  svfsum /= 0._wp )  THEN
-            i = searchsorted(svfnorm_report_thresh, svfsum / (1._wp-skyvf(isurflt_prev)))
-            svfnorm_counts(i) = svfnorm_counts(i) + 1
-
-            svf(1, isvf_surflt:nsvfl) = svf(1, isvf_surflt:nsvfl) / svfsum * (1._wp-skyvf(isurflt_prev))
-        ENDIF
-        !TODO we should be able to deallocate skyvf, from now on we only need skyvft
+        IF ( rad_angular_discretization )  THEN
+           CALL radiation_write_debug_log( 'Load svf from the structure array to plain arrays' )
+           ALLOCATE( svf(ndsvf,nsvfl) )
+           ALLOCATE( svfsurf(idsvf,nsvfl) )
+
+           DO isvf = 1, nsvfl
+               svf(:, isvf) = (/ asvf(isvf)%rsvf, asvf(isvf)%rtransp /)
+               svfsurf(:, isvf) = (/ asvf(isvf)%isurflt, asvf(isvf)%isurfs /)
+           ENDDO
+        ELSE
+           CALL radiation_write_debug_log( 'Start SVF sort' )
+!--        sort svf ( a version of quicksort )
+           CALL quicksort_svf(asvf,1,nsvfl)
+
+           !< load svf from the structure array to plain arrays
+           CALL radiation_write_debug_log( 'Load svf from the structure array to plain arrays' )
+           ALLOCATE( svf(ndsvf,nsvfl) )
+           ALLOCATE( svfsurf(idsvf,nsvfl) )
+           svfnorm_counts(:) = 0._wp
+           isurflt_prev = -1
+           ksvf = 1
+           svfsum = 0._wp
+           DO isvf = 1, nsvfl
+!--            normalize svf per target face
+               IF ( asvf(ksvf)%isurflt /= isurflt_prev )  THEN
+                   IF ( isurflt_prev /= -1  .AND.  svfsum /= 0._wp )  THEN
+                       !< update histogram of logged svf normalization values
+                       i = searchsorted(svfnorm_report_thresh, svfsum / (1._wp-skyvf(isurflt_prev)))
+                       svfnorm_counts(i) = svfnorm_counts(i) + 1
+
+                       svf(1, isvf_surflt:isvf-1) = svf(1, isvf_surflt:isvf-1) / svfsum * (1._wp-skyvf(isurflt_prev))
+                   ENDIF
+                   isurflt_prev = asvf(ksvf)%isurflt
+                   isvf_surflt = isvf
+                   svfsum = asvf(ksvf)%rsvf !?? / asvf(ksvf)%rtransp
+               ELSE
+                   svfsum = svfsum + asvf(ksvf)%rsvf !?? / asvf(ksvf)%rtransp
+               ENDIF
+
+               svf(:, isvf) = (/ asvf(ksvf)%rsvf, asvf(ksvf)%rtransp /)
+               svfsurf(:, isvf) = (/ asvf(ksvf)%isurflt, asvf(ksvf)%isurfs /)
+
+!--            next element
+               ksvf = ksvf + 1
+           ENDDO
+
+           IF ( isurflt_prev /= -1  .AND.  svfsum /= 0._wp )  THEN
+               i = searchsorted(svfnorm_report_thresh, svfsum / (1._wp-skyvf(isurflt_prev)))
+               svfnorm_counts(i) = svfnorm_counts(i) + 1
+
+               svf(1, isvf_surflt:nsvfl) = svf(1, isvf_surflt:nsvfl) / svfsum * (1._wp-skyvf(isurflt_prev))
+           ENDIF
+           WRITE(9, *) 'SVF normalization histogram:', svfnorm_counts,  &
+                       'on thresholds:', svfnorm_report_thresh(1:svfnorm_report_num), '(val < thresh <= val)'
+           !TODO we should be able to deallocate skyvf, from now on we only need skyvft
+        ENDIF ! rad_angular_discretization
 
 !--     deallocate temporary asvf array
@@ -6067,5 +6724,5 @@
 
             CALL location_message( '    calculation of the complete CSF array', .TRUE. )
-!             CALL radiation_write_debug_log( 'Calculation of the complete CSF array' )
+            CALL radiation_write_debug_log( 'Calculation of the complete CSF array' )
 !--         sort and merge csf for the last time, keeping the array size to minimum
             CALL merge_and_grow_csf(-1)
@@ -6073,6 +6730,9 @@
 !--         aggregate csb among processors
 !--         allocate necessary arrays
-            ALLOCATE( csflt(ndcsf,max(ncsfl,ndcsf)) )
-            ALLOCATE( kcsflt(kdcsf,max(ncsfl,kdcsf)) )
+            udim = max(ncsfl,1)
+            ALLOCATE( csflt_l(ndcsf*udim) )
+            csflt(1:ndcsf,1:udim) => csflt_l(1:ndcsf*udim)
+            ALLOCATE( kcsflt_l(kdcsf*udim) )
+            kcsflt(1:kdcsf,1:udim) => kcsflt_l(1:kdcsf*udim)
             ALLOCATE( icsflt(0:numprocs-1) )
             ALLOCATE( dcsflt(0:numprocs-1) )
@@ -6108,5 +6768,4 @@
 !--             fill out real values of rsvf, rtransp
                 csflt(1,kcsf) = acsf(kcsf)%rsvf
-                csflt(2,kcsf) = acsf(kcsf)%rtransp
 !--             fill out integer values of itz,ity,itx,isurfs
                 kcsflt(1,kcsf) = acsf(kcsf)%itz
@@ -6138,7 +6797,11 @@
 !--         scatter and gather the number of elements to and from all processor
 !--         and calculate displacements
-!             CALL radiation_write_debug_log( 'Scatter and gather the number of elements to and from all processor' )
+            CALL radiation_write_debug_log( 'Scatter and gather the number of elements to and from all processor' )
             CALL MPI_AlltoAll(icsflt,1,MPI_INTEGER,ipcsflt,1,MPI_INTEGER,comm2d, ierr)
-            
+            IF ( ierr /= 0 ) THEN
+                WRITE(9,*) 'Error MPI_AlltoAll1:', ierr, SIZE(icsflt), SIZE(ipcsflt)
+                FLUSH(9)
+            ENDIF
+
             npcsfl = SUM(ipcsflt)
             d = 0
@@ -6149,11 +6812,25 @@
 
 !--         exchange csf fields between processors
-!             CALL radiation_write_debug_log( 'Exchange csf fields between processors' )
-            ALLOCATE( pcsflt(ndcsf,max(npcsfl,ndcsf)) )
-            ALLOCATE( kpcsflt(kdcsf,max(npcsfl,kdcsf)) )
-            CALL MPI_AlltoAllv(csflt, ndcsf*icsflt, ndcsf*dcsflt, MPI_REAL, &
-                pcsflt, ndcsf*ipcsflt, ndcsf*dpcsflt, MPI_REAL, comm2d, ierr)
-            CALL MPI_AlltoAllv(kcsflt, kdcsf*icsflt, kdcsf*dcsflt, MPI_INTEGER, &
-                kpcsflt, kdcsf*ipcsflt, kdcsf*dpcsflt, MPI_INTEGER, comm2d, ierr)
+            CALL radiation_write_debug_log( 'Exchange csf fields between processors' )
+            udim = max(npcsfl,1)
+            ALLOCATE( pcsflt_l(ndcsf*udim) )
+            pcsflt(1:ndcsf,1:udim) => pcsflt_l(1:ndcsf*udim)
+            ALLOCATE( kpcsflt_l(kdcsf*udim) )
+            kpcsflt(1:kdcsf,1:udim) => kpcsflt_l(1:kdcsf*udim)
+            CALL MPI_AlltoAllv(csflt_l, ndcsf*icsflt, ndcsf*dcsflt, MPI_REAL, &
+                pcsflt_l, ndcsf*ipcsflt, ndcsf*dpcsflt, MPI_REAL, comm2d, ierr)
+            IF ( ierr /= 0 ) THEN
+                WRITE(9,*) 'Error MPI_AlltoAllv1:', ierr, SIZE(ipcsflt), ndcsf*icsflt, &
+                            ndcsf*dcsflt, SIZE(pcsflt_l),ndcsf*ipcsflt, ndcsf*dpcsflt
+                FLUSH(9)
+            ENDIF
+
+            CALL MPI_AlltoAllv(kcsflt_l, kdcsf*icsflt, kdcsf*dcsflt, MPI_INTEGER, &
+                kpcsflt_l, kdcsf*ipcsflt, kdcsf*dpcsflt, MPI_INTEGER, comm2d, ierr)
+            IF ( ierr /= 0 ) THEN
+                WRITE(9,*) 'Error MPI_AlltoAllv2:', ierr, SIZE(kcsflt_l),kdcsf*icsflt, &
+                           kdcsf*dcsflt, SIZE(kpcsflt_l), kdcsf*ipcsflt, kdcsf*dpcsflt
+                FLUSH(9)
+            ENDIF
             
 #else
